//  RfSettingsController.m

#import "ChannelController.h"
#import "Utils.h"
#import <ASRP31N_SDK/ASRP31N_SDK.h>
@interface ChannelController ()<ASRP31NSDKDelegate>
{
   
}
@property (weak, nonatomic) IBOutlet UITextField *olChannel;
@property (weak, nonatomic) IBOutlet UILabel *olChannelInfo;
- (IBAction)rightBarButtonItemClicked:(id)sender;
@end

@implementation ChannelController

//----------------------------------------------
#pragma mark - Lifecycle
//----------------------------------------------
- (void)viewDidLoad
{
    [super viewDidLoad];
    [self.olChannel setText:@"--"];
}

- (void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
    [ASRP31NSDK sharedInstance].delegate = self;
    [[ASRP31NSDK sharedInstance] getChannel];
}

-(void)viewWillDisappear:(BOOL)animated
{
    [super viewWillDisappear:YES];
    [ASRP31NSDK sharedInstance].delegate = nil;
}

//----------------------------------------------
#pragma mark - IBAction
//----------------------------------------------
- (IBAction)rightBarButtonItemClicked:(id)sender
{    
    [self.olChannel resignFirstResponder];
    [[ASRP31NSDK sharedInstance] setChannel:[self.olChannel.text integerValue] ];
}

//----------------------------------------------
#pragma mark - ASRP31NSDK Delegate
//----------------------------------------------
- (void)ASRP31N:(ASRP31NSDK *)ASRP31N receivedChannel:(uint8_t)channel offset:(uint8_t)offset;
{
    dispatch_async(dispatch_get_main_queue(),^{
        [self.olChannel setText:[NSString stringWithFormat:@"%d",channel]];
    });
    [[ASRP31NSDK sharedInstance] getFreqHoppingTable];
}

- (void)ASRP31N:(ASRP31NSDK *)ASRP31N receivedDidSetChParam:(uint8_t)statusCode
{
    switch (statusCode) {
        case ASRP31NSDKCommonStatusSuccess:
            [Utils showAlert:@"Success" message:@"Changed Channel Data" view:self];
            break;
            
        case ASRP31NSDKCommonStatusFailure:
            [Utils showAlert:@"Fail" message:@"Changed Channel Data" view:self];
            break;
        default:
            break;
    }
}

- (void)ASRP31N:(ASRP31NSDK *)ASRP31N receivedHoppingTable:(NSData *)table
{
    NSMutableString *strChannel = [[NSMutableString alloc]init];
    Byte *data     = (Byte*) [table bytes];
    int nLen       = data[0];
    
    for(int i=1; i<nLen+1; i++)
    {
        NSString *str = [NSString stringWithFormat:@"%d,",data[i]];
        [strChannel appendString:str];
    }
    
    NSString *strInfo = [NSString stringWithFormat:@"Size : %d \n %@",nLen,strChannel];
    dispatch_async(dispatch_get_main_queue(),^{
        [self.olChannelInfo setText:strInfo];
    });
}

- (void)ASRP31N:(ASRP31NSDK *)ASRP31N receivedErrDetailReceived:(NSData *)errCode
{
    NSString *errMessage = [NSString stringWithFormat:@"%@",errCode];
    [Utils showAlert:@"Err code" message:errMessage view:self];
}

- (void)ASRP31N:(ASRP31NSDK *)ASRP31N changeNetworkState:(ASRP31NSDKNetworkState)state error:(NSError *)error
{
    switch (state) {
            
        case ASRP31NSDKNetworkStateDisconnected:
            [Utils showAlert:@"Fail" message:@"The network connection is lost." view:self];
            break;
            
        case ASRP31NSDKNetworkStateError:
            break;
            
        default:
            break;
    }
}

@end
