//  AboutController.m
//
#import "InfroController.h"
#import <ASRP31N_SDK/ASRP31N_SDK.h>
#import "Utils.h"
@interface InfroController()
{
     
}

@property (weak, nonatomic) IBOutlet UILabel *olModel;
@property (weak, nonatomic) IBOutlet UILabel *olRegion;
@property (weak, nonatomic) IBOutlet UILabel *olBattery;
@property (weak, nonatomic) IBOutlet UILabel *olHWV;
@property (weak, nonatomic) IBOutlet UILabel *olFWV;
@property (weak, nonatomic) IBOutlet UILabel *olRFODModule;
@property (weak, nonatomic) IBOutlet UILabel *olSDKVersion;
@property (weak, nonatomic) IBOutlet UILabel *olAppVersion;
@end

@implementation InfroController

//----------------------------------------------
#pragma mark - IBAction
//----------------------------------------------
- (id)initWithStyle:(UITableViewStyle)style
{
    self = [super initWithStyle:style];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)viewDidLoad
{
    [super viewDidLoad];
}

-(void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
    [ASRP31NSDK sharedInstance].delegate = self;
    [self.olAppVersion setText:[self getAppVersion]];
    [self.olSDKVersion setText: [[ASRP31NSDK sharedInstance] getSDKVersion]];
    
    /*20190621  Response Time Out*/
    [Utils showLoadingView:@"Check Reader Info" timeOut:df_TIMEOUT_DEFAULT];
    [self performSelector:@selector(onTickGetRegion) withObject:nil afterDelay:0.5f];
   
    
}

-(void)viewDidDisappear:(BOOL)animated
{
    [super viewDidDisappear:YES];
    
    [ASRP31NSDK sharedInstance].delegate = nil;
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
}

//----------------------------------------------
#pragma mark - PrivateMethod
//----------------------------------------------
- (void) onTickGetRegion
{
    [[ASRP31NSDK sharedInstance] getRegion];
}

- (void) onTickGetRFIDModuleVersion
{
    [[ASRP31NSDK sharedInstance] getRFIDMoudleVersion];
}

/* APP version */
- (NSString *)getAppVersion
{
    NSDictionary *infoDictionary = [[NSBundle mainBundle] infoDictionary];
    NSString *majorVersion = [infoDictionary objectForKey:@"CFBundleShortVersionString"];
    NSString *minorVersion = [infoDictionary objectForKey:@"CFBundleVersion"];
    return [NSString stringWithFormat:@"%major :%@ (%@)", majorVersion, minorVersion];
}

//----------------------------------------------
#pragma mark - ASRP31NSDK Delegate
//----------------------------------------------
/* Region Infomation */
- (void)ASRP31N:(ASRP31NSDK *)ASRP31N receivedRegion:(uint8_t)region;
{
    NSString *sRegion = @"--";
    switch (region) {
        case 0x11:
            sRegion = @"Korea";
            break;
            
        case 0x21:
            sRegion = @"US Wide";
            break;
            
        case 0x22:
            sRegion = @"US Narrow";
            break;
            
        case 0x31:
            sRegion = @"Europe";
            break;
            
        case 0x41:
            sRegion = @"Japan";
            break;
            
        case 0x52:
            sRegion = @"China";
            break;
            
        case 0x61:
            sRegion = @"Brazil";
            break;
            
        default:
            sRegion = @"Unknown";
            break;
    }
    
    dispatch_async(dispatch_get_main_queue(),^{
        self.olRegion.text = sRegion;
    });
    [self onTickGetRFIDModuleVersion];
}

/* RFID Module Version Infomation */
- (void)ASRP31N:(ASRP31NSDK *)ASRP31N receivedRfidModuleVersion:(NSString *)version;
{
    dispatch_async(dispatch_get_main_queue(),^{
        self.olRFODModule.text = version;
    });
    /*20190621  Response Time Out*/
    [Utils hiddenLoadingView];
   
}




@end
