//  KillController.m

#import "KillController.h"
#import "SelectedTagInfo.h"
#import "Utils.h"
#import <ASRP31N_SDK/ASRP31N_SDK.h>
#import "PhyUtility.h"

@interface KillController ()<ASRP31NSDKDelegate>
{
    
}

@property (weak, nonatomic) IBOutlet UITextField *olTargetEpc;
@property (weak, nonatomic) IBOutlet UITextField *olKillPassword;

@end

@implementation KillController

//----------------------------------------------
#pragma mark - Lifecycle
//----------------------------------------------
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view.
}

- (void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
    [ASRP31NSDK sharedInstance].delegate = self;
    SelectedTagInfo *selectTag =  [SelectedTagInfo sharedInstance];
    self.olTargetEpc.text =   selectTag.selectedTagEPC;
}

- (void)viewWillDisappear:(BOOL)animated
{
    [super viewWillDisappear:animated];
    [ASRP31NSDK sharedInstance].delegate = nil;
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

//----------------------------------------------
#pragma mark - IBAction
//----------------------------------------------
- (IBAction)rightBarButtonItemClicked:(id)sender
{
    [self.olTargetEpc resignFirstResponder];

    NSString *hexaString = self.olKillPassword.text;
    NSScanner* pScanner = [NSScanner scannerWithString: hexaString];
    uint32_t killpassword;
    [pScanner scanHexInt: &killpassword];
    NSData *epcs       = [self.olTargetEpc.text hexStringToBytes];
    [[ASRP31NSDK sharedInstance] setKillTag:killpassword epc:epcs];
}

//----------------------------------------------
#pragma mark - ASRP31NSDKDelegate
//----------------------------------------------
- (void)ASRP31N:(ASRP31NSDK *)ASRP31N receivedDidKilled:(uint8_t)statusCode
{
    switch (statusCode) {
        case ASRP31NSDKCommonStatusSuccess:
            [Utils showAlert:@"Success" message:@"Killed" view:self];
            break;
            
        case ASRP31NSDKCommonStatusFailure:
            [Utils showAlert:@"Fail" message:@"Killed" view:self];
            break;
        default:
            break;
    }
}

- (void)ASRP31N:(ASRP31NSDK *)ASRP31N receivedErrDetail:(NSData *)errCode
{
    NSString *err = [NSString stringWithFormat:@"%@",errCode];
    [Utils showAlert:@"Err" message:err view:self];
}

- (void)ASRP31N:(ASRP31NSDK *)ASRP31N changeNetworkState:(ASRP31NSDKNetworkState)state error:(NSError *)error
{
    switch (state) {
            
        case ASRP31NSDKNetworkStateDisconnected:
            [Utils showAlert:@"Fail" message:@"The network connection is lost." view:self];
            break;
            
        case ASRP31NSDKNetworkStateError:
            break;
            
        default:
            break;
    }
}

@end
