//  LockController.m

#import "LockController.h"
#import "SelectedTagInfo.h"
#import "Utils.h"
#import <ASRP31N_SDK/ASRP31N_SDK.h>
#import "PhyUtility.h"
@interface LockController ()<ASRP31NSDKDelegate>
{
}
@end

@implementation LockController

//----------------------------------------------
#pragma mark - Lifecycle
//----------------------------------------------
- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view.
}

- (void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
    SelectedTagInfo *selectTag =  [SelectedTagInfo sharedInstance];
    self.olTargetEpc.text =   selectTag.selectedTagEPC;
    [ASRP31NSDK sharedInstance].delegate = self;
}

- (void)viewWillDisappear:(BOOL)animated
{
    [super viewWillDisappear:animated];
    [ASRP31NSDK sharedInstance].delegate = nil;
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

//----------------------------------------------
#pragma mark - IBAction
//----------------------------------------------
- (IBAction)rightBarButtonItemClicked:(id)sender
{
    [self.olTargetEpc resignFirstResponder];

    NSString *hexaString = self.olAccessPassword.text;
    NSScanner* pScanner = [NSScanner scannerWithString: hexaString];
    uint32_t accesspassword;
    [pScanner scanHexInt: &accesspassword];

    uint32_t lock = 0;
    uint32_t seed = (uint32_t)self.olAction.selectedSegmentIndex;

    switch (self.olTargetMemory.selectedSegmentIndex) {
        case 0: // Kill
            lock = (seed << 8) | (3 << 18);
            break;
        case 1: // Access
            lock = (seed << 6) | (3 << 16);
            break;
        case 2: // EPC
            lock = (seed << 4) | (3 << 14);
            break;
        case 3: // TID
            lock = (seed << 2) | (3 << 12);
            break;
        case 4: // USER
            lock = (seed << 0) | (3 << 10);
            break;
        default:
            break;
    }

    NSData *epcs       = [self.olTargetEpc.text hexStringToBytes];
    [[ASRP31NSDK sharedInstance] setLockTagMemory:accesspassword epc:epcs lockData:lock];
}

//----------------------------------------------
#pragma mark - ASRP31NSDK Delegate
//----------------------------------------------
 - (void)ASRP31N:(ASRP31NSDK *)ASRP31N receivedDidLocked:(uint8_t)statusCode;
{
    if(statusCode == ASRP31NSDKCommonStatusSuccess)
        [Utils showAlert:@"Confirm" message:@"Lock Tag" view:self];
}

- (void)ASRP31N:(ASRP31NSDK *)ASRP31N receivedErrDetail:(NSData *)errCode
{
    NSString *err = [NSString stringWithFormat:@"%@",errCode];
    [Utils showAlert:@"Err" message:err view:self];
}


- (void)ASRP31N:(ASRP31NSDK *)ASRP31N changeNetworkState:(ASRP31NSDKNetworkState)state error:(NSError *)error
{
    switch (state) {
            
        case ASRP31NSDKNetworkStateDisconnected:
            [Utils showAlert:@"Fail" message:@"The network connection is lost." view:self];
            break;
            
        case ASRP31NSDKNetworkStateError:
            break;
            
        default:
            break;
    }
}

@end
